using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace JoyLib
{
    public class Joystick
    {
        public static int GetJoystickCount()
        {
            int joyMax = (int)Win32.joyGetNumDevs();
            int count = 0;
            for (uint i = 0; i < joyMax; i++)
            {
                JoyCaps jc = new JoyCaps();
                uint ret = Win32.joyGetDevCapsW(i, ref jc, (uint)Marshal.SizeOf(jc));
                if (ret == 0)
                {
                    count++;
                }
                else
                {
                    break;
                }
            }
            return count;
        }

        public static JoystickInfo GetJoystickInfo(int joyIndex)
        {
            JoyCaps jc = new JoyCaps();
            uint ret = Win32.joyGetDevCapsW((uint)joyIndex, ref jc, (uint)Marshal.SizeOf(jc));
            if (ret != 0) throw new Exception();
            return new JoystickInfo(jc);
        }

        public static JoystickState GetState(int joyIndex)
        {
            JoyInfoEx jie = new JoyInfoEx();
            jie.dwSize = Marshal.SizeOf(jie);
            jie.dwFlags = (int)Win32.JOY_RETURNALL;
            Win32.joyGetPosEx(joyIndex, ref jie);
            return new JoystickState(jie);
        }
    }
}
